Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1582 by niro, Wed Dec 28 12:04:33 2011 UTC revision 1649 by niro, Fri Jan 13 21:04:02 2012 UTC
# Line 10  Line 10 
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 SMAGENAME="$1"  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc.global  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18  source ${MLIBDIR}/mage4.functions.sh  source ${MLIBDIR}/mage4.functions.sh
19    source ${MLIBDIR}/smage2.functions.sh
20    
21    ## setup ##
22    SMAGENAME="$1"
23    SMAGEVERSION="$(< ${MLIBDIR}/version)"
24    
25  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
26  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
27  then  then
28   export PKGDIR=${MROOT}/${PKGDIR}   export PKGDIR=${MROOT}/${PKGDIR}
# Line 29  then Line 30  then
30   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
31  fi  fi
32    
 # sources the smage file and uses state from distribution file if exist  
 # may helpful for repository support later on  
 smagesource()  
 {  
  local file="$1"  
  local mystate  
  local mycodename  
   
  source ${file}  
   
  [[ -n ${STATE} ]] && mystate="${STATE}"  
   
  # do not overide if local state was broken or disabled!  
  case ${STATE} in  
  broken) return ;;  
  disabled) return ;;  
  esac  
   
  if [ -f ${SMAGESCRIPTSDIR}/distribution ]  
  then  
  source ${SMAGESCRIPTSDIR}/distribution  
  [[ -n ${STATE} ]] && mystate="${STATE}"  
  fi  
  # now switch state and export it  
  STATE="${mystate}"  
 }  
   
 showversion()  
 {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
   
 die()  
 {  
  xtitleclean  
  echo -e ${COLRED}"Exited ${BASH_SOURCE} at line no ${BASH_LINENO}."${COLDEFAULT}  
  echo "SMAGE failed: $@"  
  exit 1  
 }  
   
 die_pipestatus()  
 {  
  # the status change if we do any parameter declarations!!  
  # dont do this anymore, keep this in mind!  
  #  
  # local pos="$1"  
  # local comment="$2"  
  #  
  # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"  
  #  
  [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"  
 }  
   
 xtitle()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
   
 xtitleclean()  
 {  
  if [[ ${TERM} = xterm ]]  
  then  
  echo -ne "\033]0;\007"  
  fi  
  return 0  
 }  
   
 syncsmage2()  
 {  
  xtitle "Updating smage2-script tree ..."  
  local i  
  for i in ${SMAGE2RSYNC}  
  do  
  rsync ${RSYNC_FETCH_OPTIONS} ${i} ${SMAGESCRIPTSDIR}  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  done  
   
  # clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
   
 # $1 filename  
 get_db_md5_sum()  
 {  
  local DB_FILE  
  local MD5_FILE  
  local i  
   
  DB_ENTRY="$(basename $1)"  
  MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} ${SMAGESUFFIX})"  
   
  i="$(cat ${MD5_FILE}| grep ${DB_ENTRY} | cut -d' ' -f1)"  
   
  echo "${i}"  
 }  
   
 download_sources()  
 {  
  [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0  
   
  local count=${#SRC_URI[*]}  
  local uri  
  local subdir  
  local outputdir  
  local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"  
  local fetching  
  local i  
   
  # check if FETCHING is needed  
  if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5  
  then  
  # md5's ok, no fetching needed  
  fetching=false  
  else  
  fetching=true  
  fi  
   
  if [[ ${fetching} = true ]]  
  then  
  for ((i=0; i < count; i++))  
  do  
  # url to file  
  uri="${SRC_URI[${i}]%%' '*}"  
   
  # subdir in sources dir; the my_SRCI_URI file goes to there  
  subdir="${SRC_URI[${i}]##*' '}"  
   
  # if $subdir is not equal with $uri then an other dir is used  
  if [[ ${uri} != ${subdir} ]]  
  then  
  outputdir="${SOURCEDIR}/${PNAME}/${subdir}"  
  else  
  outputdir="${SOURCEDIR}/${PNAME}"  
  fi  
   
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"  
  mdownload --uri "${uri}" --dir "${outputdir}" || die "Could not download '${uri}'"  
   
  # unset them to be sure  
  unset uri  
  unset subdir  
  unset outputdir  
  done  
   
  # recheck md5 sums after download  
  echo  
  echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"  
  mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"  
  echo  
  else  
  echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"  
  fi  
   
  # not needed anymore  
  unset SRC_URI  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_prepare()  
 {  
  echo "no src_prepare defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_compile()  
 {  
  echo "no src_compile defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_check()  
 {  
  echo "no src_check defined"  
  return 0  
 }  
   
 # dummy function, used if that does not exist in smage file  
 src_install()  
 {  
  echo "no src_install defined"  
  return 0  
 }  
   
 mlibdir()  
 {  
  local libdir=lib  
  [[ ${ARCH} = x86_64 ]] && libdir=lib64  
   
  echo "${libdir}"  
 }  
   
 mconfigure()  
 {  
  if [ -x ./configure ]  
  then  
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --build=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  --libdir=/usr/$(mlibdir) \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
   
 minstall()  
 {  
  if [ -f ./[mM]akefile -o -f ./GNUmakefile ]  
  then  
  make prefix=${BINDIR}/usr \  
  datadir=${BINDIR}/usr/share \  
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  libdir=${BINDIR}/usr/$(mlibdir) \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
   
 mmake()  
 {  
  make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"  
 }  
   
 munpack()  
 {  
  local SRCFILE  
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [[ -z $2 ]]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  [[ ! -d ${DEST} ]] && install -d ${DEST}  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  gz)  
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  xz)  
  IFTAR="$(basename $SRCFILE .xz)"  
  IFTAR="${IFTAR##*.}"  
  if [[ ${IFTAR} = tar ]]  
  then  
  tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."  
  else  
  pushd ${DEST} > /dev/null  
  xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."  
  popd > /dev/null  
  fi  
  ;;  
  tbz2|mpks|mpk)  
  tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."  
  ;;  
  tgz)  
  tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."  
  ;;  
  txz|mpkzs|mpkz)  
  tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."  
  ;;  
  rar)  
  unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."  
  ;;  
  zip|xpi)  
  unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."  
  ;;  
  rpm)  
  pushd ${DEST} > /dev/null  
  rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."  
  tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."  
  if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]  
  then  
  rm ${DEST}/${SRCFILE/.rpm/.tar.gz}  
  fi  
  ;;  
  *)  
  die "munpack failed"  
  ;;  
  esac  
 }  
   
 mpatch()  
 {  
  local PATCHOPTS  
  local PATCHFILE  
  local i  
   
  PATCHOPTS=$1  
  PATCHFILE=$2  
   
  if [[ -z $2 ]]  
  then  
  PATCHFILE=$1  
   
  ## patch level auto-detection, get patch level  
  for ((i=0; i < 10; i++))  
  do  
  patch --dry-run -Np${i} -i ${SOURCEDIR}/${PNAME}/${PATCHFILE} > /dev/null  
  if [[ $? = 0 ]]  
  then  
  PATCHOPTS="-Np${i}"  
  break  
  fi  
  done  
  fi  
   
  echo -e "${COLBLUE}*** ${COLGREEN}Applying patch '${PATCHFILE}'${COLDEFAULT}"  
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
 mlibtoolize()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--verbose --install --force"  
   
  libtoolize ${opts} || die "running: mlibtoolize ${opts}"  
 }  
   
 mautoreconf()  
 {  
  local opts="$@"  
  [[ -z ${opts} ]] && opts="--verbose --install --force"  
   
  autoreconf ${opts} || die "running: mautoreconf ${opts}"  
 }  
   
 minstalldocs()  
 {  
  local docfiles  
  local doc  
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for doc in ${docfiles}  
  do  
  if [ -f ${doc} ]  
  then  
  if [[ ${SMAGE_COMPRESSDOC} = true ]]  
  then  
  cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "gzipping +installing ${doc}."  
  chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "fixing permissions of ${doc}."  
  else  
  install -m 0644 ${SRCDIR}/${i} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."  
  fi  
  fi  
  done  
 }  
   
 mstriplibs()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null  
 }  
   
 mstripbins()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null  
 }  
   
 mstripstatic()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"  
  find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null  
 }  
   
 mstriplibtoolarchive()  
 {  
  local stripdir="$@"  
   
  [[ -z ${stripdir} ]] && stripdir="${BINDIR}"  
  find ${stripdir} ! -type d -name \*.la | xargs file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null  
 }  
   
 mpurgetargets()  
 {  
  local stripdir="$@"  
  local target  
   
  [[ -z ${stripdir} ]] && stripdir=${BINDIR}  
  # nothing to do in this case  
  [[ -z ${PURGE_TARGETS[*]} ]] && return  
   
  for target in ${PURGE_TARGETS[*]}  
  do  
  # check if target is a regex pattern without any slashes  
  if [[ ${target} = ${target//\/} ]]  
  then  
  find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null  
  else  
  rm -f -- ${target} 2> /dev/null  
  fi  
  done  
 }  
   
 mcompressdocs()  
 {  
  local bindir="$@"  
   
  if [ -d ${bindir}/usr/share/man ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man  
  fi  
   
  if [ -d ${bindir}/usr/share/info ]  
  then  
  echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"  
  ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info  
  fi  
 }  
   
 sminclude()  
 {  
  local i  
   
  if [[ -n "$@" ]]  
  then  
  for i in $@  
  do  
  echo "--- Including ${SMAGESCRIPTSDIR}/include/${i}.sminc"  
  source ${SMAGESCRIPTSDIR}/include/${i}.sminc  
  done  
  echo  
  fi  
 }  
   
 setup_distcc_environment()  
 {  
  if [ -x /usr/bin/distcc ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using DistCC for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/distcc/bin:${PATH} || die "distcc: could not export new $PATH"  
   
  export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  
   
  # creating distcc tempdir  
  install -o distcc -g daemon -d ${DISTCC_DIR}  
  chmod 1777 ${DISTCC_DIR}  
  fi  
 }  
   
 setup_ccache_environment()  
 {  
  if [ -x /usr/bin/ccache ]  
  then  
  echo -e "${COLBLUE}---${COLGREEN} Using CCache for compilation ...${COLDEFAULT}"  
  export PATH=/usr/$(mlibdir)/ccache/bin:${PATH} || die "ccache: could not export new $PATH"  
  fi  
 }  
   
   
 # fixes given dependencies to match a MAGE_TARGET  
 # fix_mage_deps -target s/depend # <-- note -target !  
 fix_mage_deps()  
 {  
  local target="$1"  
  local depend="$2"  
  local NDEPEND  
  local sym dep cat pver pname  
   
  # deps and provides are special  
  # they must be fixed to match the target  
   
  # run this only if target and depend is not empty  
  if [ -n "${target}" ] && [ -n "${depend}" ]  
  then  
  # fix DEPEND  
  while read sym dep  
  do  
  # ignore empty lines  
  [[ -z ${dep} ]] && continue  
   
  cat="$(dirname ${dep})"  
  # change if not virtual  
  if [[ ${cat} = virtual ]]  
  then  
  pname="$(basename ${dep})"  
  else  
  # fix pver to target-pver  
  # to get pname-target-pver  
   
  # doing it backwards !  
  pver="${dep##*-}"  
  # full pver  
  pname="$(basename ${dep/-${pver}/})${target}-${pver}"  
  fi  
   
  # do not add empty lines  
  if [ -z "${NDEPEND}" ]  
  then  
  NDEPEND="${sym} ${cat}/${pname}"  
  else  
  NDEPEND="${NDEPEND}  
  ${sym} ${cat}/${pname}"  
  fi  
   
  unset cat pname pver  
  done << EOF  
 ${depend}  
 EOF  
  # set NDEPEND to DEPEND  
  depend="${NDEPEND}"  
  fi  
   
  echo "${depend}"  
 }  
   
 # build_mage_script(): helper functions for regen_mage_tree()  
 # generates an mage file with given information in smage file  
 # needs at least:  
 #   PNAME                 name of pkg  
 #   PVER                  version  
 #   PBUILD                revision  
 #   PCATEGORIE            categorie of the pkg  
 #   STATE                 state of pkg stable|unstable|old  
 #   DESCRIPTION           va short description (opt)  
 #   HOMEPAGE              homepage (opt)  
 #   DEPEND                runtime dependencies (opt)  
 #   SDEPEND               add. needed deps to build the pkg (opt)  
 #   PROVIDE               provides a virtual (opt)  
 #  
 # special tags:  
 #   PKGTYPE               type of pkg  
 #   INHERITS              which functions get included  
 #   SPECIAL_FUNCTIONS     special functions which should also be added  
 #                         warning: they get killed before the build starts !  
 #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent  
 #   SPLIT_PACKAGE_BASE    base package name for splitpackages  
 #                         (only in the resulting magefile}  
 #  
 #   MAGE_TREE_DEST        target destination of the generated tree  
 #   REGEN_MAGE_TREE       set to 'true' to enable this  
 #  
 # gets called with build_mage_script target  
 build_mage_script()  
 {  
  local magefile  
  local dest  
  local target  
  local split_pkg_base  
  local sym  
  local depname  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # determinate which suffix this mage file should get, if any  
  [[ $1 = --target ]] && shift && target="-$1"  
   
  # mark package as splitpackage  
  [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"  
   
  # name of magefile  
  magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"  
   
  # destination to magefile  
  dest="${MAGE_TREE_DEST}/${PCATEGORIE}/${PNAME}${target}/${magefile}"  
   
  # show what we are doing  
  echo -e "${COLBLUE}===${COLGREEN} generating mage file:${COLDEFAULT}"  
  echo "${dest}"  
   
  install -d "$(dirname ${dest})"  
  # now build the mage file  
  > ${dest}  
   
  # pgkname and state  
  echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}  
  echo "STATE=\"${STATE}\"" >> ${dest}  
   
  # description and homepage  
  echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}  
  echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}  
   
  # special tags and vars  
  echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}  
   
  # echo MAGE_TARGETS ## note -target is needed !  
  echo "MAGE_TARGETS=\"${target}\"" >> ${dest}  
   
  # split package base  
  echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}  
   
  # add special vars  
  if [ -n "${SPECIAL_VARS}" ]  
  then  
  local i  
  for i in ${SPECIAL_VARS}  
  do  
  # being tricky here :)  
  echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}  
  done  
  fi  
   
  # add at least all includes  
  if [ -n "${INHERITS}" ]  
  then  
  echo -n "minclude"  >> ${dest}  
  local i  
  for i in ${INHERITS}  
  do  
  echo -n " ${i}"  >> ${dest}  
  done  
  # a CRLF is needed here!  
  echo >> ${dest}  
  fi  
   
  # deps and provides  
  echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}  
  echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}  
  echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}  
   
  # add special functions  
  if [ -n "${SPECIAL_FUNCTIONS}" ]  
  then  
  local i  
  for i in ${SPECIAL_FUNCTIONS}  
  do  
  # add to mage (quotes needed !)  
  typeset -f "${i}" >> ${dest}  
  # unset to be safe (quotes needed !)  
  #unset "${i}" <-- later to get every target built  
  done  
  fi  
   
  # pre|post-install|removes  
  typeset -f preinstall >> ${dest}  
  typeset -f postinstall >> ${dest}  
  typeset -f preremove >> ${dest}  
  typeset -f postremove >> ${dest}  
 }  
   
 regen_mage_tree()  
 {  
  local subpackage  
   
  # build them only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  # run it without targets  
  if [[ -n ${MAGE_TARGETS} ]]  
  then  
  # build for each target a mage file  
  # run it with several targets  
  echo  
  for subpackage in ${MAGE_TARGETS}  
  do  
  build_mage_script --target "${subpackage}"  
  done  
  echo  
   
  # run it for splitpackages  
  elif [[ -n ${SPLIT_PACKAGES} ]]  
  then  
  local split_pkg_base="${PNAME}"  
  # save smage environment  
  split_save_variables  
  # build for each subpackage a mage file  
  # run it with several targets  
  echo  
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  # get the right variables for the split  
  export PNAME="${subpackage}"  
  split_info_${subpackage}  
  # get the preinstall etc  
  split_export_inherits ${subpackage}  
  build_mage_script --split-pkg-base "${split_pkg_base}"  
  # delete split preinstall etc  
  split_delete_inherits ${subpackage}  
  # restore smage environment  
  split_restore_variables  
  done  
  echo  
  # unset all saved smage variables  
  split_unset_variables  
   
  else  
  echo  
  build_mage_script  
  echo  
  fi  
  fi  
   
  # now unset all uneeded vars to be safe  
  # unset PKGNAME <-- don't do that; smage needs this var  
  # unset to be safe (quotes needed !)  
 # for i in ${SPECIAL_FUNCTIONS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_FUNCTIONS  
 # for i in ${SPECIAL_VARS}  
 # do  
 # unset "${i}"  
 # done  
  unset SPECIAL_VARS  
  unset STATE  
  unset DESCRIPTION  
  unset HOMEPAGE  
  unset PKGTYPE  
  unset INHERITS  
  unset DEPEND  
  unset SDEPEND  
  unset PROVIDE  
  unset preinstall  
  unset postinstall  
  unset preremove  
  unset postremove  
 }  
   
 split_save_variables()  
 {  
  export SAVED_PNAME="${PNAME}"  
  export SAVED_PVER="${PVER}"  
  export SAVED_PBUILD="${PBUILD}"  
  export SAVED_PCATEGORIE="${PCATEGORIE}"  
  export SAVED_DESCRIPTION="${DESCRIPTION}"  
  export SAVED_HOMEPAGE="${HOMEPAGE}"  
  export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"  
  export SAVED_STATE="${STATE}"  
  export SAVED_PKGTYPE="${PKGTYPE}"  
  export SAVED_INHERITS="${INHERITS}"  
  export SAVED_DEPEND="${DEPEND}"  
  export SAVED_SDEPEND="${SDEPEND}"  
  export SAVED_PROVIDE="${PROVIDE}"  
  export SAVED_NOPKGBUILD="${NOPKGBUILD}"  
  export SAVED_PKGTYPE="${PKGTYPE}"  
   
  # bindir too  
  export SAVED_BINDIR="${BINDIR}"  
   
  # export the SPLIT_PACKAGE_BASE  
  export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"  
   
  # functions  
  if [[ ! -z $(typeset -f preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=SAVED_$(typeset -f preinstall)  
  eval "${saved_preinstall}"  
  export -f SAVED_preinstall  
  fi  
   
  if [[ ! -z $(typeset -f postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=SAVED_$(typeset -f postinstall)  
  eval "${saved_postinstall}"  
  export -f SAVED_postinstall  
  fi  
   
  if [[ ! -z $(typeset -f preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=SAVED_$(typeset -f preremove)  
  eval "${saved_preremove}"  
  export -f SAVED_preremove  
  fi  
   
  if [[ ! -z $(typeset -f postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=SAVED_$(typeset -f postremove)  
  eval "${saved_postremove}"  
  export -f SAVED_postremove  
  fi  
 }  
   
 split_restore_variables()  
 {  
  export PNAME="${SAVED_PNAME}"  
  export PVER="${SAVED_PVER}"  
  export PBUILD="${SAVED_PBUILD}"  
  export PCATEGORIE="${SAVED_PCATEGORIE}"  
  export DESCRIPTION="${SAVED_DESCRIPTION}"  
  export HOMEPAGE="${SAVED_HOMEPAGE}"  
  export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"  
  export STATE="${SAVED_STATE}"  
  export PKGTYPE="${SAVED_PKGTYPE}"  
  export INHERITS="${SAVED_INHERITS}"  
  export DEPEND="${SAVED_DEPEND}"  
  export SDEPEND="${SAVED_SDEPEND}"  
  export PROVIDE="${SAVED_PROVIDE}"  
  export NOPKGBUILD="${SAVED_NOPKGBUILD}"  
  export PKGTYPE="${SAVED_PKGTYPE}"  
   
  # bindir too  
  export BINDIR="${SAVED_BINDIR}"  
   
  # functions  
  if [[ ! -z $(typeset -f SAVED_preinstall) ]]  
  then  
  # rename the old one  
  local saved_preinstall  
  saved_preinstall=$(typeset -f SAVED_preinstall)  
  eval "${saved_preinstall/SAVED_/}"  
  export -f preinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postinstall) ]]  
  then  
  # rename the old one  
  local saved_postinstall  
  saved_postinstall=$(typeset -f SAVED_postinstall)  
  eval "${saved_postinstall/SAVED_/}"  
  export -f postinstall  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_preremove) ]]  
  then  
  # rename the old one  
  local saved_preremove  
  saved_preremove=$(typeset -f SAVED_preremove)  
  eval "${saved_preremove/SAVED_/}"  
  export -f preremove  
  fi  
   
  if [[ ! -z $(typeset -f SAVED_postremove) ]]  
  then  
  # rename the old one  
  local saved_postremove  
  saved_postremove=$(typeset -f SAVED_postremove)  
  eval "${saved_postremove/SAVED_/}"  
  export -f postremove  
  fi  
 }  
   
 split_unset_variables()  
 {  
  # unset saved vars; not needed anymore  
  unset SAVED_PNAME  
  unset SAVED_PVER  
  unset SAVED_PBUILD  
  unset SAVED_PCATEGORIE  
  unset SAVED_DESCRIPTION  
  unset SAVED_HOMEPAGE  
  unset SAVED_SPECIAL_VARS  
  unset SAVED_STATE  
  unset SAVED_PKGTYPE  
  unset SAVED_INHERITS  
  unset SAVED_DEPEND  
  unset SAVED_SDEPEND  
  unset SAVED_PROVIDE  
  unset SAVED_BINDIR  
  unset SAVED_NOPKGBUILD  
  unset SAVED_PKGTYPE  
  unset SPLIT_PACKAGE_BASE  
  unset -f SAVED_preinstall  
  unset -f SAVED_postinstall  
  unset -f SAVED_preremove  
  unset -f SAVED_postremove  
 }  
   
 split_export_inherits()  
 {  
  local subpackage="$1"  
  local func  
  local newfunc  
   
  for func in preinstall postinstall preremove postremove  
  do  
  if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]  
  then  
  newfunc=$(typeset -f ${func}_${subpackage})  
  newfunc="${newfunc/_${subpackage} (/ (}"  
  eval "${newfunc}"  
  fi  
  done  
 }  
   
 split_delete_inherits()  
 {  
  local subpackage="$1"  
  local func  
   
  for func in preinstall postinstall preremove postremove  
  do  
  if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]  
  then  
  unset -f ${func}  
  fi  
  done  
  }  
   
 export_inherits()  
 {  
  local include="$1"  
  shift  
   
  while [ "$1" ]  
  do  
  local functions="$1"  
   
  # sanity checks  
  [ -z "${include}" ] && die "export_inherits(): \$include not given."  
  [ -z "${functions}" ] && die "export_inherits(): \$functions not given."  
   
  eval "${functions}() { ${include}_${functions} ; }"  
   
  # debug  
  [[ ${MAGEDEBUG} = on ]] && typeset -f "${functions}"  
   
  shift  
  done  
 }  
   
 generate_package_md5sum()  
 {  
  local dest  
  local pcat  
  local pname  
  local pver  
  local pbuild  
  local parch  
  local target  
  local pkgname  
   
  # very basic getops  
  for i in $*  
  do  
  case $1 in  
  --pcat|-c) shift; pcat="$1" ;;  
  --pname|-n) shift; pname="$1" ;;  
  --pver|-v) shift; pver="$1" ;;  
  --pbuild|-b) shift; pbuild="$1" ;;  
  --parch|a) shift; parch="$1" ;;  
  --target|t) shift; target="$1" ;;  
  esac  
  shift  
  done  
   
  # sanity checks; abort if not given  
  [ -z "${pcat}" ] && die "generate_package_md5sum() \$pcat not given."  
  [ -z "${pname}" ] && die "generate_package_md5sum() \$pname not given."  
  [ -z "${pver}" ] && die "generate_package_md5sum() \$pver not given."  
  [ -z "${pbuild}" ] && die "generate_package_md5sum() \$pbuild not given."  
  [ -z "${parch}" ] && die "generate_package_md5sum() \$parch not given."  
   
  # check needed global vars  
  [ -z "${PKGDIR}" ] && die "generate_package_md5sum() \$PKGDIR not set."  
  [ -z "${PKGSUFFIX}" ] && die "generate_package_md5sum() \$PKGSUFFIX not set."  
   
  # fix target as it may be empty !  
  [ -n "${target}" ] && target="-${target}"  
   
   
  # build pkgname  
  pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"  
   
  # build pkg-md5-sum only if requested  
  if [[ ${REGEN_MAGE_TREE} = true ]]  
  then  
  echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"  
   
  # abort if not exist  
  if [ ! -f ${PKGDIR}/${pkgname}.${PKGSUFFIX} ]  
  then  
  echo -e "${COLRED}! exists${COLDEFAULT}"  
  return 0  
  fi  
   
  # if MAGE_TREE_DEST not set use BUILDDIR  
  : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}  
   
  # setup md5 dir  
  dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"  
  install -d ${dest}  
   
  # gen md5sum  
  ( cd ${PKGDIR}; md5sum "${pkgname}.${PKGSUFFIX}" ) \  
  > ${dest}/${pkgname}.md5  
  echo -e "${COLGREEN}done${COLDEFAULT}"  
  fi  
 }  
   
 source_pkg_build()  
 {  
  if [[ ${PKGTYPE} = virtual ]]  
  then  
  echo "Virtual package detected; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  if [[ ! -d ${SOURCEDIR}/${PNAME} ]]  
  then  
  echo "No SRC_URI defined; src-pkg-tarball not necessary ..."  
  return 0  
  fi  
   
  [ -z "${SRCPKGDIR}" ] && die "\$SRCPKGDIR not found. Please setup your ${MAGERC} correctly."  
   
  echo -e "${COLGREEN}Creating source package tarball ... ${COLDEFAULT}"  
   
  # include the smage2 file  
  cp ${SMAGENAME} ${SOURCEDIR}/${PNAME}  
   
  ( cd ${SOURCEDIR}; tar cvjf ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${PNAME}; )  
  [[ ! -d ${SRCPKGDIR} ]] && install -d ${SRCPKGDIR}  
  mv ${BUILDDIR}/${PNAME}-${PVER}-${PBUILD}.tar.bz2 ${SRCPKGDIR}/${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX}  
   
  echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"  
 }  
   
 step_by_step()  
 {  
  if [[ ${STEP_BY_STEP} = true ]]  
  then  
  echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"  
  echo "Press [enter] to continue"  
  read  
  fi  
 }  
   
   
33  # print out our version  # print out our version
34  showversion  showversion
35  echo  echo
36    
37  if [ -z "$1" ]  if [[ -z ${SMAGENAME} ]]
38  then  then
39   echo "No .smage2 file given. Exiting."   echo "No .smage2 file given. Exiting."
40   echo   echo
41   exit 1   exit 1
42  fi  fi
43    
44    # load supported mage features
45    load_mage_features
46    
47  # updating smage2-scripts  # updating smage2-scripts
48  if [[ $1 = update ]]  if [[ $1 = update ]]
49  then  then
# Line 1241  then Line 161  then
161   do   do
162   # build md5sum for existing packages   # build md5sum for existing packages
163   generate_package_md5sum \   generate_package_md5sum \
164   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
165   --pname "${PNAME}" \   --pname "${PNAME}" \
166   --pver "${PVER}" \   --pver "${PVER}" \
167   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1260  then Line 180  then
180   split_info_${subpackage}   split_info_${subpackage}
181   # build md5sum for existing packages   # build md5sum for existing packages
182   generate_package_md5sum \   generate_package_md5sum \
183   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
184   --pname "${PNAME}" \   --pname "${PNAME}" \
185   --pver "${PVER}" \   --pver "${PVER}" \
186   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1274  then Line 194  then
194   else   else
195   # build md5sum for existing packages   # build md5sum for existing packages
196   generate_package_md5sum \   generate_package_md5sum \
197   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
198   --pname "${PNAME}" \   --pname "${PNAME}" \
199   --pver "${PVER}" \   --pver "${PVER}" \
200   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
# Line 1308  fi Line 228  fi
228  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
229  then  then
230   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
231   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
232    
233   # abort if given file is not a source pkg   # abort if given file is not a source pkg
234   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1329  then Line 249  then
249   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
250  fi  fi
251    
252    if [ "$1" == "--resume" -a -n "$2" ]
253    then
254     msetfeature "resume"
255     SMAGENAME="$2"
256    fi
257    
258  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."  [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ] && die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."
259  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&  [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
# Line 1342  fi Line 267  fi
267  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
268    
269  smagesource ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
270  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
271  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
272  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"  SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
273    
# Line 1352  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 277  echo -e "${COLGREEN}Compiling ${PKGNAME}
277  # auto regen mage tree if requested  # auto regen mage tree if requested
278  regen_mage_tree  regen_mage_tree
279    
280  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkgbuild"
281  then  then
282   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
283   then   then
# Line 1362  then Line 287  then
287  fi  fi
288    
289  # download sources  # download sources
290  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
291    
292  # fixes some issues with these functions  # fixes some issues with these functions
293  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
# Line 1373  export -f src_install || die "src_instal Line 298  export -f src_install || die "src_instal
298  # fixes some compile issues  # fixes some compile issues
299  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
300  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
301  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
302    then
303     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
304    else
305     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
306    fi
307    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
308  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
309  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
310    
   
311  # setup distcc  # setup distcc
312  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
313  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
314    
315  # setup ccache  # setup ccache
316  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
317    
318  # clean up builddir if a previously one exist  if mqueryfeature "resume"
 if [ -d ${BUILDDIR} ]  
319  then  then
320   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
321    
322  # clean up srcdir if a previously unpacked one exist   # setup build logging
323  if [ -d ${SRCDIR} ]   [[ ! -d /var/log/smage ]] && install -d /var/log/smage
324  then   if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
325   rm -rf ${SRCDIR}   then
326  fi   bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
327     fi
328     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
329    
330  # clean up bindir if a previous build exist or create a new one  else
331  if [ -d ${BINDIR} ]   # clean up builddir if a previously one exist
332  then   if [ -d ${BUILDDIR} ]
333   rm -rf ${BINDIR}   then
334  fi   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
335  install -d ${BINDIR} || die "couldn't create \$BINDIR."   fi
336     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
337    
338  # clean up package temp dir if a previous build exist   # clean up srcdir if a previously unpacked one exist
339  if [ -d ${BUILDDIR}/${PKGNAME} ]   if [ -d ${SRCDIR} ]
340  then   then
341   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${SRCDIR}
342  fi   fi
343    
344  # setup build logging   # clean up bindir if a previous build exist or create a new one
345  [[ ! -d /var/log/smage ]] && install -d /var/log/smage   if [ -d ${BINDIR} ]
346  echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log   then
347     rm -rf ${BINDIR}
348  src_prepare | ${SMAGE_LOG_CMD}   fi
349  die_pipestatus 0 "src_prepare failed"   install -d ${BINDIR} || die "couldn't create \$BINDIR."
 step_by_step $_  
   
 src_compile | ${SMAGE_LOG_CMD}  
 die_pipestatus 0 "src_compile failed"  
 step_by_step $_  
350    
351  # only run checks if requested   # clean up package temp dir if a previous build exist
352  if [[ ${MAGE_CHECK} != true ]]   if [ -d ${BUILDDIR}/${PKGNAME} ]
353  then   then
354   echo "MAGE_CHECK not requested; src_check() will not be run!" | ${SMAGE_LOG_CMD}   rm -rf ${BUILDDIR}/${PKGNAME}
355   step_by_step src_check   fi
356  else  
357   src_check | ${SMAGE_LOG_CMD}   # clean up stamps dir
358   die_pipestatus 0 "src_check failed"   if [ -d ${BUILDDIR}/.stamps ]
359   step_by_step $_   then
360     rm -rf ${BUILDDIR}/.stamps
361     fi
362    
363     # setup build logging
364     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
365     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
366  fi  fi
367    
368  # build several subpackages  if [[ ${PKGTYPE} = virtual ]]
 if [[ -n ${SPLIT_PACKAGES} ]]  
369  then  then
370   # save bindir & pname   echo "virtual package detected; nothing will be build ..."
371   split_save_variables   # automatically set !pkgbuild here too
372   export SAVED_BINDIR="${BINDIR}"   msetfeature "!pkgbuild"
  for subpackage in ${SPLIT_PACKAGES}  
  do  
  if typeset -f src_install_${subpackage} > /dev/null  
  then  
  # export subpackage bindir  
  export BINDIR="${SAVED_BINDIR}_${subpackage}"  
  # export PNAME, several internal function and include  
  # rely on this variable  
  export PNAME="${subpackage}"  
   
  echo  
  echo -en "${COLBLUE}*** ${COLDEFAULT}"  
  echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"  
  echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"  
  echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."  
   
  src_install_${subpackage} | ${SMAGE_LOG_CMD}  
  die_pipestatus 0 "src_install_${subpackage} failed"  
  step_by_step $_  
  fi  
  done  
  # restore bindir & pname  
  split_restore_variables  
  # unset all saved smage variables  
  split_unset_variables  
373  else  else
374   src_install | ${SMAGE_LOG_CMD}   ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
375   die_pipestatus 0 "src_install failed"   die_pipestatus 0 "src_prepare failed"
376   step_by_step $_   resume_stamp src_prepare
377     step_by_step src_prepare
378    
379     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
380     die_pipestatus 0 "src_compile failed"
381     resume_stamp src_compile
382     step_by_step src_compile
383    
384     # only run checks if requested
385     if mqueryfeature "!check"
386     then
387     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
388     else
389     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
390     die_pipestatus 0 "src_check failed"
391     resume_stamp src_check
392     fi
393     step_by_step src_check
394    
395     # build several subpackages
396     if [[ -n ${SPLIT_PACKAGES} ]]
397     then
398     # save bindir & pname
399     split_save_variables
400     export SAVED_BINDIR="${BINDIR}"
401     for subpackage in ${SPLIT_PACKAGES}
402     do
403     if typeset -f src_install_${subpackage} > /dev/null
404     then
405     # export subpackage bindir
406     export BINDIR="${SAVED_BINDIR}_${subpackage}"
407     # export PNAME, several internal function and include
408     # rely on this variable
409     export PNAME="${subpackage}"
410    
411     echo
412     echo -en "${COLBLUE}*** ${COLDEFAULT}"
413     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
414     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
415     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
416    
417     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
418     die_pipestatus 0 "src_install_${subpackage} failed"
419     resume_stamp src_install_${subpackage}
420     step_by_step src_install_${subpackage}
421     fi
422     done
423     # restore bindir & pname
424     split_restore_variables
425     # unset all saved smage variables
426     split_unset_variables
427     else
428     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
429     die_pipestatus 0 "src_install failed"
430     resume_stamp src_install
431     step_by_step src_install
432     fi
433  fi  fi
434    
435  # compressing doc, info & man files  # echo for sake of good-looking
436  if [[ -n ${SPLIT_PACKAGES} ]]  echo
437    
438    if mqueryfeature "!compressdoc"
439    then
440     echo -e "!compressdoc detected; documentation will not be compressed ..."
441    elif mqueryfeature "!pkgbuild"
442  then  then
443   for subpackage in ${SPLIT_PACKAGES}   echo "!pkgbuild detected; skipping documentation compression..."
  do  
  mcompressdocs ${BINDIR}_${subpackage}  
  done  
444  else  else
445   mcompressdocs ${BINDIR}   # compressing doc, info & man files
446     if [[ -n ${SPLIT_PACKAGES} ]]
447     then
448     for subpackage in ${SPLIT_PACKAGES}
449     do
450     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
451     resume_stamp post-mcompressdoc_${subpackage}
452     done
453     else
454     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
455     resume_stamp post-mcompressdoc
456     fi
457  fi  fi
458    
459  if [[ ${SMAGE_STRIP_LIBTOOL} = true ]]  if mqueryfeature "!libtool"
460  then  then
461     if mqueryfeature "!pkgbuild"
462     then
463     echo "!pkgbuild detected; skipping libtool archive stripping ..."
464     else
465   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
466   then   then
467   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
468   do   do
469   echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
470   mstriplibtoolarchive ${BINDIR}_${subpackage}   run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
471     resume_stamp post-mstriplibtoolarchive_${subpackage}
472   done   done
473   else   else
474   echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
475   mstriplibtoolarchive ${BINDIR}   run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
476     resume_stamp post-mstriplibtoolarchive
477   fi   fi
478     fi
479  fi  fi
480    
481  if [[ ${SMAGE_PURGE} = true ]]  if mqueryfeature "purge"
482  then  then
483     if mqueryfeature "!pkgbuild"
484     then
485     echo "!pkgbuild detected; skipping file purgation..."
486     else
487   if [[ -n ${SPLIT_PACKAGES} ]]   if [[ -n ${SPLIT_PACKAGES} ]]
488   then   then
489   for subpackage in ${SPLIT_PACKAGES}   for subpackage in ${SPLIT_PACKAGES}
490   do   do
491   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
492   mpurgetargets ${BINDIR}_${subpackage}   run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
493     resume_stamp post-mpurgetargets_${subpackage}
494   done   done
495   else   else
496   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
497   mpurgetargets ${BINDIR}   run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
498     resume_stamp post-mpurgetargets
499   fi   fi
500     fi
501  fi  fi
502    
503  # stripping all bins and libs  # stripping all bins and libs
504  case ${NOSTRIP} in  if mqueryfeature "!strip"
505   true|TRUE|yes|y)  then
506   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "!strip detected; Package will not be stripped ..."
507   ;;  elif mqueryfeature "!pkgbuild"
508   *)  then
509   if [[ -n ${SPLIT_PACKAGES} ]]   echo "!pkgbuild detected; skipping stripping of the package ..."
510   then  else
511   for subpackage in ${SPLIT_PACKAGES}   if [[ -n ${SPLIT_PACKAGES} ]]
512   do   then
513   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"   for subpackage in ${SPLIT_PACKAGES}
514   mstripbins ${BINDIR}_${subpackage}   do
515   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
516   mstriplibs ${BINDIR}_${subpackage}   run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
517   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"   resume_stamp post-mstripbins_${subpackage}
518   mstripstatic ${BINDIR}_${subpackage}   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
519   done   run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
520   else   resume_stamp post-mstriplibs_${subpackage}
521   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
522   mstripbins ${BINDIR}   run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
523   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"   resume_stamp post-mstripstatic_${subpackage}
524   mstriplibs ${BINDIR}   done
525   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"   else
526   mstripstatic ${BINDIR}   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
527   fi   run_resume post-mstripbins || mstripbins ${BINDIR}
528   ;;   resume_stamp post-mstripbins
529  esac   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
530     run_resume post-mstriplibs || mstriplibs ${BINDIR}
531     resume_stamp post-mstriplibs
532     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
533     run_resume post-mstripstatic || mstripstatic ${BINDIR}
534     resume_stamp post-mstripstatic
535     fi
536    fi
537    
538  # the new buildpkg command  if mqueryfeature "!pkgbuild"
539  case ${NOPKGBUILD} in  then
540   true|TRUE|yes|y)   echo -e "!pkgbuild detected; Package will not be build ..."
541   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  else
  ;;  
  *)  
542   # build several targets   # build several targets
543   if [[ -n ${MAGE_TARGETS} ]]   if [[ -n ${MAGE_TARGETS} ]]
544   then   then
# Line 1555  case ${NOPKGBUILD} in Line 548  case ${NOPKGBUILD} in
548   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
549   then   then
550   # run it   # run it
551   ${target}_pkgbuild   run_resume post-${target}_pkgbuild || ${target}_pkgbuild
552     resume_stamp post-${target}_pkgbuild
553   fi   fi
554   # now create the target package   # now create the target package
555   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${target} || ${MLIBDIR}/pkgbuild_dir.sh \
556   "${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
557   ${BINDIR} || die "target: ${target} package-build failed"   ${BINDIR} || die "target: ${target} package-build failed"
558     resume_stamp post-pkg_builddir_${target}
559    
560   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
561   generate_package_md5sum \   run_resume post-md5sum_${target} || generate_package_md5sum \
562   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
563   --pname "${PNAME}" \   --pname "${PNAME}" \
564   --pver "${PVER}" \   --pver "${PVER}" \
565   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
566   --parch "${ARCH}" \   --parch "${ARCH}" \
567   --target "${target}"   --target "${target}"
568     resume_stamp post-md5sum_${target}
569    
570   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
571   done   done
572    
573   # build several subpackages   # build several subpackages
# Line 1584  case ${NOPKGBUILD} in Line 580  case ${NOPKGBUILD} in
580   export PNAME="${subpackage}"   export PNAME="${subpackage}"
581   split_info_${PNAME}   split_info_${PNAME}
582    
583   # jump to next one if NOPKGBUILD is set in split_info   # jump to next one if !pkgbuild is set in split_info
584   case ${NOPKGBUILD} in   mqueryfeature "!pkgbuild" && continue
  true|TRUE|yes|y) continue ;;  
  esac  
585    
586   # check if an special subpackage_pkgbuild exists   # check if an special subpackage_pkgbuild exists
587   if typeset -f ${PNAME}_pkgbuild > /dev/null   if typeset -f ${PNAME}_pkgbuild > /dev/null
588   then   then
589   # run it   # run it
590   ${PNAME}_pkgbuild   run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
591     resume_stamp post-${PNAME}_pkgbuild
592   fi   fi
593   # now create the target package   # now create the target package
594   ${MLIBDIR}/pkgbuild_dir.sh \   run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir.sh \
595   "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \   "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
596   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"   "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
597     resume_stamp post-pkg_builddir_${PNAME}
598    
599   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
600   generate_package_md5sum \   run_resume post-md5sum_${PNAME} || generate_package_md5sum \
601   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
602   --pname "${PNAME}" \   --pname "${PNAME}" \
603   --pver "${PVER}" \   --pver "${PVER}" \
604   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
605   --parch "${ARCH}"   --parch "${ARCH}"
606     resume_stamp post-md5sum_${PNAME}
607    
608   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
609    
610   # restore smage environment   # restore smage environment
611   split_restore_variables   split_restore_variables
# Line 1617  case ${NOPKGBUILD} in Line 614  case ${NOPKGBUILD} in
614   split_unset_variables   split_unset_variables
615    
616   else   else
617   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
618     resume_stamp post-pkg_builddir
619    
620   # build pkg-md5-sum if requested   # build pkg-md5-sum if requested
621   generate_package_md5sum \   run_resume post-md5sum || generate_package_md5sum \
622   --pcat "${PCATEGORIE}" \   --pcat "${PCAT}" \
623   --pname "${PNAME}" \   --pname "${PNAME}" \
624   --pver "${PVER}" \   --pver "${PVER}" \
625   --pbuild "${PBUILD}" \   --pbuild "${PBUILD}" \
626   --parch "${ARCH}"   --parch "${ARCH}"
627     resume_stamp post-md5sum
628    
629   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
630   fi   fi
631    
632   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
633   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   if mqueryfeature "srcpkgbuild"
634   ;;   then
635  esac   run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
636     resume_stamp post-srcpkgbuild
637     fi
638    fi
639    
640  if [[ ${SMAGE_BUILD_LOGGING} != false ]]  if mqueryfeature "buildlog"
641  then  then
642   bzip2 -9f /var/log/smage/${PKGNAME}.log   bzip2 -9f /var/log/smage/${PKGNAME}.log
643  else  else
644   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
645  fi  fi
646    
 # for sure  
 unset NOPKGBUILD  
 unset NOSTRIP  
   
647  xtitleclean  xtitleclean

Legend:
Removed from v.1582  
changed lines
  Added in v.1649